#ifndef _USB7062A_DEVICE_
#define _USB7062A_DEVICE_

#include "windows.h"

// #################### ԻͶ #####################
// Humanized data types definition
typedef char				I8;		// 8λз
typedef unsigned char		U8;		// 8λ޷
typedef short				I16;	// 16λз
typedef unsigned short		U16;	// 16λ޷
typedef long				I32;	// 32λз
typedef unsigned long		U32;	// 32λ޷
typedef __int64				I64;	// 64λз
typedef unsigned __int64	U64;	// 64λ޷
typedef float				F32;	// 32λ(ȣͬΪlabVIEWеSGL)
typedef double				F64;	// 64λ(˫ȣͬΪlabVIEWеDBL)
//***********************************************************
// USB7062A_SetDeviceFunctionеlFunctionʹùܵѡ
const long USB7062A_FUNCTIONG_DCV			= 0x00; // ֱѹ
const long USB7062A_FUNCTIONG_ACV			= 0x01;	// ѹ
const long USB7062A_FUNCTIONG_DCI			= 0x02;	// ֱ
const long USB7062A_FUNCTIONG_ACI			= 0x03;	// 
const long USB7062A_FUNCTIONG_2W			= 0x04;	// 2ߵ赵
const long USB7062A_FUNCTIONG_4W			= 0x05;	// 4ߵ赵
const long USB7062A_FUNCTIONG_FRE			= 0x06;	// Ƶʵ
const long USB7062A_FUNCTIONG_CAP			= 0x07;	// ݵ
const long USB7062A_FUNCTIONG_DIODE			= 0x08;	// ܵ
const long USB7062A_FUNCTIONG_ONOFF			= 0x09; // ͨϵ

//////////////////////////////////////////////////////////////////
// ֱѹѡ
const long USB7062A_DCV_INPUT_N0_200MV		= 0x00;	// 0-200mV
const long USB7062A_DCV_INPUT_N0_2000MV		= 0x01;	// 0-2000mV
const long USB7062A_DCV_INPUT_N0_20000MV	= 0x02;	// 0-20000mV
const long USB7062A_DCV_INPUT_N0_200000MV	= 0x03;	// 0-200000mV
const long USB7062A_DCV_INPUT_N0_300000MV	= 0x04;	// 0-300000mV
//////////////////////////////////////////////////////////////////
// ѹѡ
const long USB7062A_ACV_INPUT_N0_200MV		= 0x00;	// 0-200mV
const long USB7062A_ACV_INPUT_N0_2000MV		= 0x01;	// 0-2000mV
const long USB7062A_ACV_INPUT_N0_20000MV	= 0x02;	// 0-20000mV
const long USB7062A_ACV_INPUT_N0_200000MV	= 0x03;	// 0-200000mV
const long USB7062A_ACV_INPUT_N0_300000MV	= 0x04;	// 0-300000mV

//////////////////////////////////////////////////////////////////
// ֱѡ
const long USB7062A_DCI_INPUT_N0_2MA		= 0x00;	// 0-2mA
const long USB7062A_DCI_INPUT_N0_20MA		= 0x01;	// 0-20mA
const long USB7062A_DCI_INPUT_N0_200MA		= 0x02;	// 0-200mA
const long USB7062A_DCI_INPUT_N0_1A			= 0x03;	// 0-1A

//////////////////////////////////////////////////////////////////
// ѡ
const long USB7062A_ACI_INPUT_N0_20MA		= 0x00;	// 0-20mA
const long USB7062A_ACI_INPUT_N0_200MA		= 0x01;	// 0-200mA
const long USB7062A_ACI_INPUT_N0_1A			= 0x02;	// 0-1A

//////////////////////////////////////////////////////////////////
// 2ߵѡ
const long USB7062A_2W_INPUT_N0_P200		= 0x00; // 0-200
const long USB7062A_2W_INPUT_N0_P2K			= 0x01; // 0-2K
const long USB7062A_2W_INPUT_N0_P20K		= 0x02; // 0-20K
const long USB7062A_2W_INPUT_N0_P200K		= 0x03; // 0-200K
const long USB7062A_2W_INPUT_N0_P1M			= 0x04; // 0-1M
const long USB7062A_2W_INPUT_N0_P10M		= 0x05; // 0-10M
const long USB7062A_2W_INPUT_N0_P100M		= 0x06; // 0-100M

//////////////////////////////////////////////////////////////////
// 4ߵѡ
const long USB7062A_4W_INPUT_N0_P200		= 0x00; // 0-200
const long USB7062A_4W_INPUT_N0_P2K			= 0x01; // 0-2K
const long USB7062A_4W_INPUT_N0_P20K		= 0x02; // 0-20K
const long USB7062A_4W_INPUT_N0_P200K		= 0x03; // 0-200K
const long USB7062A_4W_INPUT_N0_P1M			= 0x04; // 0-1M
const long USB7062A_4W_INPUT_N0_P10M		= 0x05; // 0-10M
const long USB7062A_4W_INPUT_N0_P100M		= 0x06; // 0-100M

//////////////////////////////////////////////////////////////////
// ѡ
const long USB7062A_CAP_INPUT_N0_P2NF		= 0x00; // 0-2nF
const long USB7062A_CAP_INPUT_N0_P20NF		= 0x01; // 0-20nF
const long USB7062A_CAP_INPUT_N0_P200NF		= 0x02; // 0-200nF
const long USB7062A_CAP_INPUT_N0_P2UF		= 0x03; // 0-2uF
const long USB7062A_CAP_INPUT_N0_P20UF		= 0x04; // 0-20uF
const long USB7062A_CAP_INPUT_N0_P200UF		= 0x05; // 0-200uF

//////////////////////////////////////////////////////////////////
// ܵ
const long USB7062A_DIODE_INPUT_N0_2V		= 0x00;

//////////////////////////////////////////////////////////////////
// USB7062A_SetDeviceDigitsеñֱlDigitsʹõѡ
const long USB7062A_DIGITS_5_12				= 0x00;	// 5.5Digists
const long USB7062A_DIGITS_4_12				= 0x01;	// 4.5Digists
const long USB7062A_DIGITS_3_12				= 0x02;	// 3.5Digists

//////////////////////////////////////////////////////////////////
// USB7062A_SetDCInputImpedanceеֱ迹lImpedanceʹõѡ
// ѡֱʱҪô迹
const long USB7062A_DC_IMPEDANCE_10M		= 0x00;	// ֱ迹Ϊ10M
const long USB7062A_DC_IMPEDANCE_20G		= 0x01;	// ֱ迹Ϊ20G

//////////////////////////////////////////////////////////////////
// USB7062A_SetFilterSpeedе˲ٶlSpeedʹõѡ
// ѡʱҪô˲ٶ
const long USB7062A_AC_FILTERSPEED_SLOW		= 0x00;	// ˲
const long USB7062A_AC_FILTERSPEED_QUICK	= 0x01;	// ˲

//////////////////////////////////////////////////////////////////
// USB7062A_SetDevTrigModeеĴģʽlTrigModeʹõѡ
const long USB7062A_TRIGMODE_AUTO			= 0x00;	// Զ
const long USB7062A_TRIGMODE_EXT			= 0x01;	// ⲿ
const long USB7062A_TRIGMODE_SINGLE			= 0x02;	// δ


//////////////////////////////////////////////////////////////////
// USB7062A_SetDevTrigDirеĴlTrigDirʹõѡ
const long USB7062A_TRIGDIR_NEGATIVE		= 0x00;	// 򴥷(½ش)
const long USB7062A_TRIGDIR_POSITIVE		= 0x01;	// 򴥷(ش)

//////////////////////////////////////////////////////////////////
// USB7062A_SetDevExtOutputPolarityеⲿlPolarityʹõѡ
const long USB7062A_POLARITY_HIGH			= 0x00;	// ߵƽ
const long USB7062A_POLARITY_LOW			= 0x01;	// ͵ƽ


// #################### ״̬ṹUSB7062A_STATUS #####################
typedef struct _USB7062A_STATUS
{
	U32 nComplete;				// ת־, =1:ת
	U32 nPowerMode;				// ģʽ, =0:USB߹, =1:ⲿ
	U32 nOverVoltage;			// ⹩״̬, =0:⹩, =1:⹩ѹ
} USB7062A_STATUS, *PUSB7062A_STATUS;


// ################################ 豸ӿ ################################
#ifndef _USB7062A_DRIVER_
#define DEVLIB __declspec(dllimport)
#else
#define DEVLIB __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	// ################################ DEV豸 ################################
	HANDLE DEVLIB WINAPI USB7062A_DEV_Create(					// 豸(hDevice), ɹʵʾ,ʧ򷵻INVALID_HANDLE_VALUE(-1),ɵGetLastError()ԭ
										U32 nDeviceIdx,			// 豸(߼Ż, ʹɲbUsePhysIdx)
										BOOL bUsePhysIdx);		// Ƿʹ, =TRUE:ʹ, =FALSE:ʹ߼										

	U32 DEVLIB WINAPI USB7062A_DEV_GetCount(void);				// ȡø豸̨,ɹֵ>0, ʧܷ0(ɵGetLastError()ԭ)

	BOOL DEVLIB WINAPI USB7062A_DEV_GetSpeed(					// ȡ豸ӵUSB˿ٶ, 
										HANDLE hDevice,			// 豸,DEV_Create()
										U32* pSpeed);			// USBӿٶȣ=1:USB1.0, =2:USB2.0, =3:USB3.0

	BOOL DEVLIB WINAPI USB7062A_DEV_GetCurrentIdx(				// ָ豸е߼ź
										HANDLE hDevice,			// 豸,DEV_Create()
										U32* pLgcIdx,			// ص߼
										U32* pPhysIdx);			// ص

	BOOL DEVLIB WINAPI USB7062A_DEV_Release(HANDLE hDevice);	// ͷ豸(ؼ)

	// ################################ ñʵֺ ################################
	BOOL DEVLIB FAR PASCAL USB7062A_SetDeviceFunction(			// ñܵѡ
										HANDLE hDevice,			// 豸,DEV_Create()
										LONG lFunction);		// ܵѡ

	BOOL DEVLIB FAR PASCAL USB7062A_SetDeviceInputRange(		// 
										HANDLE hDevice,			// 豸,DEV_Create()
										LONG lInputRange);		// 

	BOOL DEVLIB FAR PASCAL USB7062A_SetDeviceDigits(			// ñֱ
										HANDLE hDevice,			// 豸,DEV_Create()
										LONG lDigits);			// ñֱ

	BOOL DEVLIB FAR PASCAL USB7062A_SetDCInputImpedance(		// ֱ迹
										HANDLE hDevice,			// 豸,DEV_Create()
										LONG lImpedance);		// ֱ迹

	BOOL DEVLIB FAR PASCAL USB7062A_SetFilterSpeed(				// ˲ٶ
										HANDLE hDevice,			// 豸,DEV_Create()
										LONG lSpeed);			// ˲ٶ

	BOOL DEVLIB FAR PASCAL USB7062A_SetDevTrigMode(				// ôģʽ
										HANDLE hDevice,			// 豸,DEV_Create()
										LONG lTrigMode);		// ģʽ

	BOOL DEVLIB FAR PASCAL USB7062A_SingleTrig(					// δģʽΪδģʽЧ
										HANDLE hDevice);		// 豸,DEV_Create()

	BOOL DEVLIB FAR PASCAL USB7062A_SetDevTrigPara(				// ⲿ 
										HANDLE hDevice,			// 豸,DEV_Create()
										LONG lTrigDir,			// ⲿ(0:½ش,1:ش)
										LONG lEnable,			// ʹֹܻⲿ1:ʹܣ0:ֹ
										LONG lPolarity,			// ⲿ(0:ߵƽ,1:͵ƽ)
										LONG lPulseWidth);		// ⲿȣλuS:065535

	BOOL DEVLIB FAR PASCAL USB7062A_GetDeviceSts(				// ȡ豸״̬
										HANDLE hDevice,			// 豸,DEV_Create()
										PUSB7062A_STATUS pStatus);		// 豸״̬ΪTRUEʱʾԶȡЧݣЧ								

	BOOL DEVLIB FAR PASCAL USB7062A_ReadDeviceData(				// ȡ豸ɼԭ
										HANDLE hDevice,			// 豸,DEV_Create()
										PLONG plADData);		// ɼ

	BOOL DEVLIB FAR PASCAL USB7062A_ReadDeviceValue(			// ȡ豸ʵ
										HANDLE hDevice,			// 豸,DEV_Create()
										double* pdValue);		// ɼ

	BOOL DEVLIB FAR PASCAL USB7062A_ReadBaseFreCNT(				// ȡ׼Ƶʼֵ
										HANDLE hDevice,			// 豸
										PULONG pluBaseFreCNTValue);// ׼Ƶʼֵ

	BOOL DEVLIB FAR PASCAL USB7062A_ReadMeasFreCNT(				// ȡźżֵ
										HANDLE hDevice,			// 豸
										PULONG pluMeasFreCNTValue);// źżֵֵ

	BOOL DEVLIB FAR PASCAL USB7062A_ReadMeasRatioCNT(			// ȡźŸߵƽļֵ
										HANDLE hDevice,			// 豸
										PULONG pluMeasRatioCNTValue);// źŸߵƽļֵ

	//####################### 豸У׼ #################################
	BOOL DEVLIB FAR PASCAL USB7062A_WriteCalibrationData(		// дУ׼
										HANDLE hDevice,			// 豸
										LONG lFunction,			// ܵѡ񣬴˴ֻеѹ͵赵
										LONG lInputRange,		// ѡ
										LONG lCalMode,			// 0ΪУ׼1ΪУ׼
										LONG lCalData);			// У׼ֵ016777216

	BOOL DEVLIB FAR PASCAL USB7062A_ReadCalibrationData(			// У׼
										HANDLE hDevice,			// 豸
										LONG lFunction,			// ܵѡ񣬴˴ֻеѹ͵赵
										LONG lInputRange,		// ѡ
										LONG lCalMode,			// 0ΪУ׼1ΪУ׼
										PLONG plCalData);		// У׼ֵ016777216

	BOOL DEVLIB FAR PASCAL USB7062A_WriteACVFreGainsData(		// д뽻У׼ʱƵֵ
										HANDLE hDevice,			// 豸
										LONG lInputRange,		// ѡ
										LONG lFreGains);		// Ƶֵ

	BOOL DEVLIB FAR PASCAL USB7062A_ReadACVFreGainsData(		// У׼ʱƵֵ
										HANDLE hDevice,			// 豸
										LONG lInputRange,		// ѡ
										PLONG plFreGains);		// Ƶֵ


	// ################################ EVENT¼ ################################
	HANDLE DEVLIB WINAPI USB7062A_EVENT_Create(void);	// ¼
	BOOL DEVLIB WINAPI USB7062A_EVENT_Release(HANDLE hEvent); // ͷ¼

#ifdef __cplusplus
}
#endif

#ifndef _CVIDEF_H
	// Զ
	#ifndef _USB7062A_DRIVER_
		#ifndef LOAD_USB7062A_LIB // ûмLIB
			#define LOAD_USB7062A_LIB
			#ifndef _WIN64
				#pragma comment(lib, "USB7062A_32.lib")
				#pragma message("======== Welcome to use our art company's products!")
				#pragma message("======== Automatically linking with USB7062A_32.dll...")
				#pragma message("======== Successfully linked with USB7062A_32.dll")
			#else
				#pragma comment(lib, "USB7062A_64.lib")
				#pragma message("======== Welcome to use our art company's products!")
				#pragma message("======== Automatically linking with USB7062A_64.dll...")
				#pragma message("======== Successfully linked with USB7062A_64.dll")
			#endif
		#endif // LOAD_USB7062A_LIB
	#endif // _USB7062A_DRIVER_
#endif // _CVIDEF_H

#endif // _USB7062A_DEVICE_